// AID-GENERATED
// =========================================================================
// This class was generated by AID - Abstract Interface Definition          
// DO NOT MODIFY, but use the org.freehep.aid.Aid utility to regenerate it. 
// =========================================================================

package hep.lcio.event;



import hep.lcio.exceptions.* ;
/**The main event interface. Holds named collections
 * with elements of type LCObject ('untyped'). Users have to cast to
 * the corresponding types.  
 *
 * @author gaede
 * @version $Id: LCEvent.aid,v 1.14 2007/11/08 19:35:37 gaede Exp $
 * @see LCCollection
 */

public interface LCEvent {

    /** Return the run number off this event.
     */
    public int getRunNumber();

    /** Returns this event's number .
     */
    public int getEventNumber();

    /** Returns the name of the detector setup used in the simulation.
     */
    public String getDetectorName();

    /** Returns the time stamp of the event.
     *  Timestamp is a unique 64 bit integer.<br>
     *  Definition: ns since January 1, 1970, 00:00:00 GMT
     */
    public long  getTimeStamp();

    /** Returns the event weight.
     */
    public double getWeight();

    /** Returns the names of the collections in the  event.
     */
    public String[] getCollectionNames();

    /** Returns the collection for the given name.
     *
     * @throws DataNotAvailableException
     */
    public LCCollection getCollection(String name) throws DataNotAvailableException;

    /** Adds a collection with the given name (has to be a valid C/C++ variable name). 
     *	Throws an exception if the name already
     *  exists in the event. NB: Adding collections is allowed even when the event is 'read only'.
     *
     *@see validateCollectionName
     *@throws EventException
     */ 
    public void addCollection(LCCollection col, String name) throws EventException;

    /** Removes (and deletes) the collection with name (if it exists in the event). 
     * Throws an exception if the event is 'read only' as defined by the read mode in LCReader.
     *
     *@throws ReadOnlyException
     */ 
    public void removeCollection(String name) throws ReadOnlyException;

    /** Parameters defined for this event.
     */
    public LCParameters getParameters();

//     //fg20040528:   added relations to the event
//     /** Returns the names of the relations in the  event.
//      */
//     public const String[]*  getRelationNames() const ;
//     /** Returns the relation for the given name.
//      *
//      * @throws DataNotAvailableException
//      */
//      public LCRelation* getRelation(const String& name) const throws DataNotAvailableException ;
//     /** Adds a relation with the given name. Throws an exception if the name already
//      * exists in the event. NB: Adding relations is allowed even when the event is 'read only'.
//      * 
//      *@throws EventException
//      */ 
//     public void addRelation(LCRelation* col ,const  String& name ) throws EventException ;
//     /** Removes (and deletes) the relation with name (if it exists in the event). 
//      * Throws an exception if the event is 'read only' as defined by the read mode in LCReader.
//      *
//      *@throws ReadOnlyException
//      */ 
//     public void removeRelation(const  String& name ) throws ReadOnlyException ;
} // class or interface

