// AID-GENERATED
// =========================================================================
// This class was generated by AID - Abstract Interface Definition          
// DO NOT MODIFY, but use the org.freehep.aid.Aid utility to regenerate it. 
// =========================================================================

package hep.lcio.io;

import hep.lcio.event.LCEvent;
import hep.lcio.event.LCRunHeader;
import java.io.IOException;


import hep.lcio.exceptions.* ;
/**Interface for writing data with LCIO. Uses interfaces 
 * from EVENT/hep.lcio.event.
 * Use LCFactory to instantiate a corresponding LCWriter object
 * for the output format at hand (SIO only, so far).
 *
 * @see LCFactory
 * @author gaede
 * @version Mar 4, 2003
 */
public interface LCWriter {

    /** Opens a file for writing. If file with given name exists, 
     * an exception is thrown. Use append or new mode instead.
     *
     *@throws IOException
     */
    public void open(String filename) throws IOException;

    /** Opens a file for writing.
     * Possible write modes are: LCIO::WRITE_NEW
     * (existing files are replaced) and LCIO::WRITE_APPEND. 
     *
     *@throws IOException
     */
    public void open(String filename, int writeMode) throws IOException;

    /** Set the compression level - needs to be called before open() otherwise
     *  call will have no effect. If not called the Writer will use default compression.<br>
     *  Valid compression levels are:
     *  <ul>
     *    <li> level <  0 : default compression </li>
     *    <li> level == 0 : no compression</li>
     *    <li> level >  0 : compression level (typically 1 (fastest) - 9 (best compression))
     *    </li>
     *  </ul>
     *  
     *  Status:  (v01-09)<br>
     *  C++: experimental code - don't use for production<br>
     *  Java: not implemented
     * 
     *@param level compression level
     */
    public void setCompressionLevel(int level);

    /** Writes the given run header to file.
     *
     *@throws IOException
     */
    public void writeRunHeader(LCRunHeader hdr) throws IOException;

    /** Writes the given event to file.
     *
     *@throws IOException
     */
    public void writeEvent(LCEvent evt) throws IOException;

    /** Closes the output file/stream.
     *
     *@throws IOException
     */
    public void close() throws IOException;

    /** Flushes the output file/stream.
     *
     *@throws IOException
     */
    public void flush() throws IOException;
} // class or interface

